# Generated by Django 5.1.7 on 2025-03-17 06:18

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='DataSource',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=50)),
                ('group_by', models.JSONField(blank=True, default=list, null=True, verbose_name='Group Fields')),
                ('filters', models.JSONField(blank=True, default=dict)),
                ('limit', models.IntegerField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Report',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('slug', models.SlugField(max_length=128, unique=True)),
                ('title', models.TextField()),
                ('description', models.TextField(blank=True, default='')),
                ('style', models.CharField(blank=True, default='', max_length=100)),
                ('notes', models.TextField(blank=True, default='')),
            ],
        ),
        migrations.CreateModel(
            name='DataModel',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=150)),
                ('model', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='contenttypes.contenttype')),
                ('source', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='models', to='reportcraft.datasource')),
            ],
        ),
        migrations.CreateModel(
            name='Entry',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('title', models.TextField(blank=True, default='')),
                ('description', models.TextField(blank=True, default='')),
                ('notes', models.TextField(blank=True, default='')),
                ('style', models.CharField(blank=True, choices=[('col-md-3', 'One Quarter'), ('col-md-4', 'One Third'), ('col-md-6', 'Half'), ('col-md-8', 'Two Thirds'), ('col-md-9', 'Three Quarters'), ('col-md-12', 'Full Width')], default='col-md-12', max_length=100, verbose_name='Width')),
                ('kind', models.CharField(choices=[('bars', 'Bar Chart'), ('table', 'Table'), ('list', 'List'), ('plot', 'XY Plot'), ('pie', 'Pie Chart'), ('histogram', 'Histogram'), ('timeline', 'Timeline'), ('text', 'Rich Text')], default='table', max_length=50, verbose_name='Type')),
                ('position', models.IntegerField(default=0)),
                ('attrs', models.JSONField(blank=True, default=dict)),
                ('source', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='entries', to='reportcraft.datasource')),
                ('report', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entries', to='reportcraft.report')),
            ],
            options={
                'verbose_name_plural': 'Entries',
                'ordering': ['report', 'position'],
            },
        ),
        migrations.CreateModel(
            name='DataField',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('name', models.SlugField()),
                ('label', models.CharField(max_length=100, null=True)),
                ('default', models.JSONField(blank=True, null=True)),
                ('expression', models.TextField(blank=True, default='')),
                ('precision', models.IntegerField(blank=True, null=True)),
                ('position', models.IntegerField(default=0)),
                ('ordering', models.IntegerField(blank=True, null=True)),
                ('model', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='fields', to='reportcraft.datamodel')),
                ('source', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='fields', to='reportcraft.datasource')),
            ],
            options={
                'ordering': ['source', 'position', 'pk'],
                'unique_together': {('name', 'source', 'model')},
            },
        ),
    ]
